unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls, Contnrs;

type
  TMainForm = class(TForm)
    SaveHere: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    CONFIG: TTabSheet;
    Label7: TLabel;
    RbtnPutDesktop: TRadioButton;
    RbtnPutWhere: TRadioButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ChkClearListOnDrop: TCheckBox;
    MemTarget: TMemo;
    PnlButton: TPanel;
    Bevel1: TBevel;
    BtnCheck: TBitBtn;
    BtnDoit: TBitBtn;
    BtnVersion: TBitBtn;
    Panel3: TPanel;
    Label6: TLabel;
    MemOut: TMemo;
    Label8: TLabel;
    ChkVerbose: TCheckBox;
    Label9: TLabel;
    ChkRestoreList: TCheckBox;
    ProgTotal: TProgressBar;
    ProgPart: TProgressBar;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnCheckClick(Sender: TObject);
    procedure BtnVersionClick(Sender: TObject);
    procedure BtnDoitClick(Sender: TObject);
  private
    FTargetList: TStringList;
    FBreakList: TStringList;
    FDictIndex: TStringList;
    FDictList: TStringList;
    function GetId(const AKey: String): String;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDropFiles(var Msg: TWMDropFiles);message WM_DROPFILES;
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    ShellApi,
    Dao360, Info;

{$R *.dfm}

const
    DUMMY_PASS: String = 'PASSWORD_HERE';
    DUMMY_STAT: String = '??';
    BOOL_TXT: array[Boolean] of String = ('@', '');

//-----------------------------------------------------------------------------
//  UTILITY
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  "<"">""&"AHTMLŐ\邽߂̕ϊ
function ConvHtmlChar(const AText: String): String;
const
    SRC_TAG: array[0..3] of String = ('&', '<', '>', '\');
    DST_TAG: array[0..3] of String = ('&amp;', '&lt;', '&gt;', '&yen;');
var
    i: Integer;
begin
    //ϊRs[
    Result := AText;

    for i := Low(SRC_TAG) to High(SRC_TAG) do
    begin
        //u
        Result := StringReplace(Result, SRC_TAG[i], DST_TAG[i], [rfReplaceAll]);
    end;
end;

//-----------------------------------------------------------------------------
//  FORM
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  tH[hbO\ɂ
//  Subject: [Delphi-ML:7773] Re: ł
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
var
    LListFileName: String;
begin
    SetFormCaption(Self);
    LoadPropertyFromFile(ChangeFileExt(ParamStr(0), '.ini'), Self);

    //  XgČ
    LListFileName := ChangeFileExt(ParamStr(0), '.dat');
    if (ChkRestoreList.Checked and FileExists(LListFileName)) then
    begin
        MemTarget.Lines.LoadFromFile(LListFileName);
    end;

    FTargetList := TStringList.Create();
    FTargetList.Sorted := True;

    FBreakList := TStringList.Create();
    FBreakList.Delimiter := DELIM_PATHPASS;

    FDictIndex := TStringList.Create();
    FDictList := TStringList.Create();
    FDictIndex.Sorted := True;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
var
    LListFileName: String;
begin
    FTargetList.Free();
    FBreakList.Free();
    FDictIndex.Free();
    FDictList.Free();

    //  Xgۑ
    LListFileName := ChangeFileExt(ParamStr(0), '.dat');
    if (ChkRestoreList.Checked) then
    begin
        MemTarget.Lines.SaveToFile(LListFileName);
    end;

    SavePropertyToFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.BtnVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  IDɕϊBقȂ镶͏ɈقȂIDɂȂ悤ɁB
function TMainForm.GetId(const AKey: String): String;
var
    LIndex: Integer;
begin
    //  łɓo^ς݂
    if (FDictIndex.Find(AKey, LIndex)) then
    begin
        LIndex := Integer(FDictIndex.Objects[LIndex]);
    end

    //  oꂩ
    else
    begin
        LIndex := FDictList.Add(AKey);
        FDictIndex.AddObject(AKey, TObject(LIndex));
    end;
    Result := 'ID' + IntToHex(LIndex, 4);
end;

//-----------------------------------------------------------------------------
//  hbOꂽƂ̏
//  Subject: [Delphi:74737] Re: t@C̑M
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    LPos: TPoint;
    //LControl: TControl;
    LCount: Integer;
    i: Integer;
    LItemName: String;
    LIndex: Integer;
begin
    //  bNĂ΃XLbv
    if (not MemTarget.Enabled) then Exit;

    //  KvȂ烊XgNA
    if (ChkClearListOnDrop.Checked) then
    begin
        FTargetList.Clear();
        MemTarget.Clear();
    end;

    //  hbvʒu擾
    DragQueryPoint(Msg.Drop, LPos);
    //  hbvʒuɂRg[擾
    //  gpȂ
    //LControl := FindDragTarget(Self.ClientToScreen(LPos), False);
    //  hbvꂽACe擾
    LCount := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
    try
        //  hbvꂽACe̖OSĎ擾
        for i := 0 to LCount - 1 do
        begin
            //  hbvꂽACê擾
            SetLength(LItemName, MAX_PATH);
            DragQueryFile(Msg.Drop, i, PChar(LItemName), MAX_PATH + 1);
            LItemName := PChar(LItemName);

            //  tH_H
            if (DirectoryExists(LItemName)) then
            begin
                //  gpȂ
                //LItemName := IncludeTrailingPathDelimiter(LItemName);
            end
            //  t@CH
            else if (FileExists(LItemName)) then
            begin
                //  d`FbN
                if (not FTargetList.Find(LItemName, LIndex)) then
                begin
                    //  d`FbNpXgɒǉ
                    FTargetList.Add(LItemName);

                    //  _~[pX[hăXgɓo^
                    LItemName := DoubleQuote(DUMMY_STAT)
                               + DELIM_PATHPASS
                               + DoubleQuote(DUMMY_PASS)
                               + DELIM_PATHPASS
                               + DoubleQuote(LItemName);
                    MemTarget.Lines.Add(LItemName);
                end;
            end;
        end;
    finally
        //  
        DragFinish(Msg.Drop);
    end;
end;

//-----------------------------------------------------------------------------
//  ڑ`FbN
procedure TMainForm.BtnCheckClick(Sender: TObject);
var
    i: Integer;
    LLine: String;
    LStat: String;
    LPass: String;
    LPath: String;
    LErr: String;
    LNgCount: Integer;
    LOkCount: Integer;
    LMsg: String;
begin
    //  1sȂΖ
    if (MemTarget.Lines.Count = 0) then Exit;

    //  bN
    MemTarget.Enabled := False;

    LNgCount := 0;
    LOkCount := 0;

    for i := 0 to MemTarget.Lines.Count - 1 do
    begin
        LLine := MemTarget.Lines.Strings[i];
        FBreakList.DelimitedText := LLine;
        if (FBreakList.Count >= 3) then
        begin
            LStat := FBreakList.Strings[0];
            LPass := FBreakList.Strings[1];
            LPath := FBreakList.Strings[2];

            //  Ă݂
            GMdb.OpenConnection(LPass, LPath, LErr);
            if (GMdb.Opened) then
            begin
                LStat := 'OK';
                Inc(LOkCount);
            end
            else
            begin
                LStat := 'NG ' + LErr;
                Inc(LNgCount);
            end;

            LLine := DoubleQuote(LStat)
                   + DELIM_PATHPASS
                   + DoubleQuote(LPass)
                   + DELIM_PATHPASS
                   + DoubleQuote(LPath);

            MemTarget.Lines.Strings[i] := LLine;

            //  ƂĂ
            GMdb.CloseConnection();
        end;
    end;

    //  bN
    MemTarget.Enabled := True;

    //  mF
    LMsg := Format('%d s̃XĝA%d ɐڑłA%d ɐڑł܂łB'#13#10
                 + 'ڑł %d ̃t@Ĉ݉͂܂B'#13#10#13#10
                 + 'uNGvŎn܂sڑłȂt@CłB'#13#10
                 + 'pX[hԈႢΏCĂB',
                 [MemTarget.Lines.Count, LOkCount, LNgCount, LOkCount]);
    AppMessageBox(LMsg, MB_OK or MB_ICONINFORMATION);
end;

//-----------------------------------------------------------------------------
//  ͊Jn
procedure TMainForm.BtnDoitClick(Sender: TObject);
var
    i: Integer;
    j: Integer;
    k: Integer;
    l: Integer;
    Ticks: Cardinal;
    LCounter: Integer;
var
    LOutName: String;
    LOutPath: String;
    LOutBack: String;
    LTemp: Integer;
    F: TextFile;
var
    LLine: String;
    LPass: String;
    LPath: String;
    LErr: String;
    LMdbPath: TStringList;
    LText: String;
    LIndexArray: array[0..5] of Boolean;
    LIdList: TStringList;
    LPkList: TStringList;
    LFkList: TStringList;
    LUkList: TStringList;
    LClList: TStringList;
    LInList: TStringList;
var
    LTableCount: Integer;
    LTable: OleVariant;

    LFieldCount: Integer;
    LField: OleVariant;

    LIndexCount: OleVariant;
    LIndex: OleVariant;

    LRelationCount: Integer;
    LRelation: OleVariant;
var
    LProp: OleVariant;
    LPropCount: Integer;
    LPropName: String;
    LPropValue: String;
begin
    ProgTotal.Position := 0;
    ProgPart.Position := 0;

    Ticks := GetTickCount();

    //-------------------------------------------------------------------------
    //  ۑ挈tF[Y

    //  1sȂΖ
    if (MemTarget.Lines.Count = 0) then Exit;

    //  bN
    MemTarget.Enabled := False;
    PnlButton.Enabled := False;

    //  bo͐於
    LOutPath := '';

    LOutName := ChangeFileExt(ExtractFileName(ParamStr(0)),
                              FormatDateTime('_yymmdd_hhnnss', Now()) + '.html');


    LOutName := ChangeFileExt(ExtractFileName(ParamStr(0)),
                              FormatDateTime('_yymmdd', Now()) + '.html');

    //  ۑ悪fXNgbv̏ꍇ
    if (RbtnPutDesktop.Checked) then
    begin
        LOutPath := IncludeTrailingPathDelimiter(GetDesktopFolderPath())
                  + ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '_out\'
                  + LOutName;
        LOutBack := LOutPath;

        LCounter := 0;
        //  ̏ꍇ͏㏑Ȃ悤ɂǂɂ
        while (FileExists(LOutPath)) do
        begin
            Inc(LCounter);
            LOutPath := ExtractFilePath(LOutBack)
                      + ChangeFileExt(ExtractFileName(LOutBack), '')
                      + '(' + IntToHex(LCounter, 2) + ')'
                      + ExtractFileExt(LOutBack);
        end;

    end
    //  ۑQƎw肷ꍇ
    else if (RbtnPutWhere.Checked) then
    begin
        SaveHere.FileName := LOutName;
        if (SaveHere.Execute()) then
        begin
            SaveHere.InitialDir := ExtractFilePath(SaveHere.FileName);
            LOutPath := SaveHere.FileName;
        end;
    end;

    //  ۑ͌܂܂H
    if (LOutPath = '') then
    begin
        //  bN
        MemTarget.Enabled := True;
        PnlButton.Enabled := True;
        Exit;
    end;

    //  tH_쐬
    ForceDirectories(ExtractFilePath(LOutPath));

    //  J[\ύX
    Screen.Cursor := crHourGlass;
    Self.Color := clYellow;
    Self.Repaint();

    //-------------------------------------------------------------------------
    //  IuWFNg쐬
    LMdbPath := TStringList.Create();

    LIdList := TStringList.Create();
    LPkList := TStringList.Create();
    LFkList := TStringList.Create();
    LUkList := TStringList.Create();
    LClList := TStringList.Create();
    LInList := TStringList.Create();

    LIdList.Sorted := True; LIdList.Duplicates := dupIgnore;
    LPkList.Sorted := True; LPkList.Duplicates := dupIgnore;
    LFkList.Sorted := True; LFkList.Duplicates := dupIgnore;
    LUkList.Sorted := True; LUkList.Duplicates := dupIgnore;
    LClList.Sorted := True; LClList.Duplicates := dupIgnore;
    LInList.Sorted := True; LInList.Duplicates := dupIgnore;

    //-------------------------------------------------------------------------
    //  t@Co̓tF[Y

    //  ۂɈӖ̂f[^o^Ă邩ǂɂ炸t@C͍
    try
        //  t@CJ
        AssignFile(F, LOutPath);
        Rewrite(F);
        try
            //-----------------------------------------------------------------
            //  wb_o
            Writeln(F, '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
            Writeln(F, '<html lang="ja"><head>');
            Writeln(F, '<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">');
            Writeln(F, '<meta http-equiv="Content-Script-Type" content="text/javascript">');
            Writeln(F, '<meta http-equiv="Content-Style-Type" content="text/css">');
            Writeln(F, '<link rev="made" href="mailto:fjtkt@ybb.ne.jp">');
            Writeln(F, '<style type="text/css"><!--');
            Writeln(F, '    body,table{font-size:x-small;}');
            Writeln(F, '    body{font-family:"sans-serif";}');
            Writeln(F, '    table{font-family:"courier new";}');
            Writeln(F, '    th{background-color:#eeeeee;}');
            Writeln(F, '    caption{text-align:left;font-weight:bold;color:#FF3333;}');
            Writeln(F, '    .caption{text-align:left;font-weight:bold;color:#FF3333;}');
            Writeln(F, '    h1,h2,h3{border-bottom-style:solid;border-bottom-width:1px;width:100%;}');
            Writeln(F, '--></style>');
            Writeln(F, '<title>Mircosoft Database File ͌ by ' + ExtractFileName(ParamStr(0)) + '</title>');
            Writeln(F, '</head><body>');

            Writeln(F, '<h1 id="PAGE_TOP">Mircosoft Database File ͌</h1>');

            Writeln(F, Format('<p align="right">Generated by <a href="http://www.geocities.jp/fjtkt/">%s Ver.%s</a> at %s'
                            + '<br>on %s</p>',
                              [ExtractFileName(ParamStr(0)),
                               GetVersionInfo(FVERREQ_FileVersion, ParamStr(0)),
                               FormatDateTime('yyyy/mm/dd hh:nn:ss', Now()),
                               GetOsInfo()]));

            //-----------------------------------------------------------------
            //  GW̃vpeB
            if (ChkVerbose.Checked) then
            begin
                Writeln(F, '<p ID="IDENGINE"><table cellpadding=3 cellspacing=0 border=1>');
                Writeln(F, '<caption>ڑGW̃vpeB</caption>');
                Writeln(F, '<tr><th nowrap>NO</th><th nowrap>vpeB</th><th nowrap>ݒl</th></tr>');

                LPropCount := GMdb.EG.Properties.Count;
                for i := 0 to LPropCount - 1 do
                begin
                    try
                        LProp := GMdb.EG.Properties[i];
                        LPropName := LProp.Name;
                        LPropValue := LProp.Value;
                    except
                        ;
                    end;
                    Writeln(F, Format('<tr><td nowrap>%d</td><td nowrap>%s</td><td nowrap>%s@</td></tr>',
                                      [i + 1, LPropName, ConvHtmlChar(LPropValue)])
                    );
                end;
                Writeln(F, '</table>');
            end;

            //-----------------------------------------------------------------
            //  [NXy[X̃vpeB
            if (ChkVerbose.Checked) then
            begin
                Writeln(F, '<p ID="IDWORKSPACE"><table cellpadding=3 cellspacing=0 border=1>');
                Writeln(F, '<caption>[NXy[X̃vpeB</caption>');
                Writeln(F, '<tr><th nowrap>NO</th><th nowrap>vpeB</th><th nowrap>ݒl</th></tr>');

                LPropCount := GMdb.WS.Properties.Count;
                for i := 0 to LPropCount - 1 do
                begin
                    try
                        LProp := GMdb.WS.Properties[i];
                        LPropName := LProp.Name;
                        LPropValue := LProp.Value;
                    except
                        ;
                    end;
                    Writeln(F, Format('<tr><td nowrap>%d</td><td nowrap>%s</td><td nowrap>%s@</td></tr>',
                                      [i + 1, LPropName, ConvHtmlChar(LPropValue)])
                    );
                end;
                Writeln(F, '</table>');
            end;

            //-----------------------------------------------------------------
            //  ڑłt@Ĉ݃XgAbv
            Writeln(F, '<h2 ID="IDFILES">Ώۃt@C</h2>');
            Writeln(F, '<p><ul>');

            for i := 0 to MemTarget.Lines.Count - 1 do
            begin
                LLine := MemTarget.Lines.Strings[i];
                FBreakList.DelimitedText := LLine;
                if (FBreakList.Count >= 3) then
                begin
                    LPass := FBreakList.Strings[1];
                    LPath := FBreakList.Strings[2];

                    //  Ă݂
                    GMdb.OpenConnection(LPass, LPath, LErr);
                    if (GMdb.Opened) then
                    begin
                        LLine := DoubleQuote(LPass)
                               + DELIM_PATHPASS
                               + DoubleQuote(LPath);

                        //  ŉ͂Ƃ͂̃Xg𗘗p
                        LMdbPath.Add(LLine);

                        //  HTMLo
                        Writeln(F, Format('<li><a href="#%s">%s</a></li>',
                                   [GetId(GMdb.FileName), GMdb.FileName]));

                        //  ƂĂ
                        GMdb.CloseConnection();
                    end;
                end;
            end;
            Writeln(F, '</ul>');

            Writeln(F, '<p>[}] PK=Primary Key; FK=Foresign Key; UK=Unique Key; IX=Index Key; NN=Not NULL; =󕶎');

            //-----------------------------------------------------------------
            //  ꂼ̃t@CɐڑHTMLo
            ProgTotal.Max := LMdbPath.Count;

            for i := 0 to LMdbPath.Count - 1 do
            begin
                ProgPart.Position := 0;
                ProgPart.Max := 5;

                LLine := LMdbPath.Strings[i];

                //  Ă݂
                GMdb.OpenConnection(LLine, LErr);
                if (GMdb.Opened) then
                begin
                    Writeln(F, Format('<h3 id="%s"><a href="#IDFILES">%s</a></h3>',
                               [GetId(GMdb.FileName), GMdb.FileName]));

                    //---------------------------------------------------------
                    //  f[^x[X̃vpeB
                    if (ChkVerbose.Checked) then
                    begin
                        Writeln(F, '<p><table cellpadding=3 cellspacing=0 border=1>');
                        Writeln(F, '<caption>f[^x[X̃vpeB</caption>');
                        Writeln(F, '<tr><th nowrap>NO</th><th nowrap>vpeB</th><th nowrap>ݒl</th></tr>');

                        LPropCount := GMdb.DB.Properties.Count;
                        for j := 0 to LPropCount - 1 do
                        begin
                            try
                                LProp := GMdb.DB.Properties[j];
                                LPropName := LProp.Name;
                                LPropValue := LProp.Value;
                            except
                                ;
                            end;
                            Writeln(F, Format('<tr><td nowrap>%d</td><td nowrap>%s</td><td nowrap>%s@</td></tr>',
                                              [j + 1, LPropName, ConvHtmlChar(LPropValue)])
                            );
                        end;
                        Writeln(F, '</table>');
                    end;
                    ProgPart.StepIt();

                    //---------------------------------------------------------
                    //  e[uꗗ

                    //  e[uBւ̎Q
                    LTableCount := GMdb.DB.TableDefs.Count;

                    Writeln(F, '<p><table cellpadding=3 cellspacing=0 border=1>'
                             + '<caption>e[uꗗ / <a href="#' + GetID(GMdb.FileName) + '_relation">[VVbv</a></caption>'
                             + '<tr>'
                             + '<th nowrap>NO</th>'
                             + '<th nowrap>e[u</th>'
                             + '<th nowrap></th>'
                             + '<th nowrap>R[h</th>'
                             + '<th nowrap>쐬</th>'
                             + '<th nowrap>XV</th>'
                             //+ '<th nowrap>Connect</th>'
                             + '<th nowrap>XV\</th>'
                             + '<th nowrap>͋K</th>'
                             + '<th nowrap>K</th>'
                             + '<th nowrap></th>'
                             + '</tr>');

                    //  e[uP̂ւ̎Q
                    for j := 0 to LTableCount - 1 do
                    begin
                        LTable := GMdb.DB.TableDefs[j];

                        Writeln(F, '<tr>'
                                 + Format('<td nowrap align="right">%d</td>', [j + 1])
                                 + Format('<td nowrap><a href="#%s_%s">%s</a></td>', [GetID(GMdb.FileName), GetID(LTable.Name), LTable.Name])
                                 + Format('<td nowrap>%s</td>', [GetTableAttr(LTable.Attributes)])
                                 + Format('<td nowrap align="right">%s</td>', [LTable.RecordCount])
                                 + Format('<td nowrap>%s</td>', [LTable.DateCreated])
                                 + Format('<td nowrap>%s</td>', [LTable.LastUpdated])
                                 //+ Format('<td nowrap>%s@</td>', [LTable.Connect])
                                 + Format('<td nowrap>%s</td>', [LTable.Updatable])
                                 + Format('<td nowrap>%s@</td>', [ConvHtmlChar(LTable.ValidationRule)])
                                 + Format('<td nowrap>%s@</td>', [ConvHtmlChar(LTable.ValidationText)])
                                 );
                        try
                            Write(F, Format('<td nowrap>%s</td>', [LTable.Properties['Description']]));
                        except
                            Write(F, '<td>@</td>');
                        end;
                        Write(F, '</tr>');
                    end;

                    Writeln(F, '</table>');
                    ProgPart.StepIt();

                    //---------------------------------------------------------
                    //  tB[hvpeBo
                    for j := 0 to LTableCount - 1 do
                    begin
                        //  e[uP̂ւ̎Q
                        LTable := GMdb.DB.TableDefs[j];

                        Writeln(F, Format('<h4 id="%s_%s"><a href="#%s">%s (in %s)</a></h4>',
                                            [GetId(GMdb.FileName), GetId(LTable.Name),
                                            GetId(GMdb.FileName), LTable.Name, GMdb.FileName]));

                        //-----------------------------------------------------
                        //  CfbNXBւ̎Q
                        LIndexCount := 0;
                        try
                            LIndexCount := LTable.Indexes.Count;
                        except
                            ;
                        end;

                        //  ̃e[uŃCfbNXL[ɐݒ肳Ă
                        //  tB[hL^Ă
                        LIdList.Clear();
                        LPkList.Clear();
                        LFkList.Clear();
                        LUkList.Clear();
                        LClList.Clear();
                        LInList.Clear();

                        //  CfbNXP̂ւ̎Q
                        for k := 0 to LIndexCount - 1 do
                        begin
                            LIndex := LTable.Indexes[k];
                            LFieldCount := LIndex.Fields.Count;

                            //  ǂݎlzɕێ
                            FillChar(LIndexArray, SizeOf(LIndexArray), False);
                            LIndexArray[0] := Boolean(LIndex.Primary);
                            LIndexArray[1] := Boolean(LIndex.Foreign);
                            LIndexArray[2] := Boolean(LIndex.Unique);
                            LIndexArray[3] := Boolean(LIndex.Clustered);
                            LIndexArray[4] := Boolean(LIndex.IgnoreNulls);

                            for l := 0 to LFieldCount - 1 do
                            begin
                                LField := LIndex.Fields[l];
                                LText := LField.Name;
                                LIdList.Add(LText);
                                if (LIndexArray[0]) then LPkList.Add(LText);
                                if (LIndexArray[1]) then LFkList.Add(LText);
                                if (LIndexArray[2]) then LUkList.Add(LText);
                                if (LIndexArray[3]) then LClList.Add(LText);
                                if (LIndexArray[4]) then LInList.Add(LText);
                            end;
                        end;

                        //-----------------------------------------------------
                        //  tB[hBւ̎Q
                        LFieldCount := 0;
                        try
                            LFieldCount := LTable.Fields.Count;
                        except
                            ;
                        end;

                        if (LFieldCount > 0) then
                        begin
                            Writeln(F, '<p><table cellpadding=3 cellspacing=0 border=1>'
                                     + '<tr>'
                                     + '<th nowrap></th>'
                                     + '<th nowrap>tB[h</th>'

                                     + '<th nowrap>PK</th>'
                                     + '<th nowrap>FK</th>'
                                     + '<th nowrap>UK</th>'
                                     + '<th nowrap>IX</th>'
                                     //+ '<th nowrap>Clusterd</th>'
                                     //+ '<th nowrap>NULL</th>'
                                     + '<th nowrap>NN</th>'
                                     + '<th nowrap></th>'

                                     + '<th nowrap>^</th>'
                                     + '<th nowrap>TCY</th>'
                                     + '<th nowrap></th>'
                                     + '<th nowrap>l</th>'
                                     + '<th nowrap>XV\</th>'
                                     + '<th nowrap>͋K</th>'
                                     + '<th nowrap>K</th>'
                                     + '<th nowrap></th>'
                                     + '</tr>');


                            //  tB[hP̂ւ̎Q
                            for k := 0 to LFieldCount - 1 do
                            begin
                                LField := LTable.Fields[k];
                                LText := LField.Name;

                                Writeln(F, '<tr>'
                                         + Format('<td nowrap align="right">%s</td>', [LField.OrdinalPosition])
                                         + Format('<td nowrap>%s</td>', [LText])

                                         + Format('<td nowrap align="center">%s</td>', [BOOL_TXT[LPkList.Find(LText, LTemp)]])
                                         + Format('<td nowrap align="center">%s</td>', [BOOL_TXT[LFkList.Find(LText, LTemp)]])
                                         + Format('<td nowrap align="center">%s</td>', [BOOL_TXT[LUkList.Find(LText, LTemp)]])
                                         + Format('<td nowrap align="center">%s</td>', [BOOL_TXT[LIdList.Find(LText, LTemp)]])
                                         //+ Format('<td nowrap>%s</td>', [BOOL_TXT[LClList.Find(LText, LTemp)]])
                                         //+ Format('<td nowrap>%s</td>', [BOOL_TXT[LInList.Find(LText, LTemp)]])
                                         + Format('<td nowrap align="center">%s</td>', [BOOL_TXT[Boolean(LField.Required)]])
                                         + Format('<td nowrap align="center">%s</td>', [BOOL_TXT[Boolean(LField.AllowZeroLength)]])

                                         + Format('<td nowrap>%s</td>', [GetType(LField.Type)])
                                         + Format('<td nowrap align="right">%s</td>', [LField.Size])
                                         + Format('<td nowrap>%s</td>', [StringReplace(GetFieldAttr(LField.Attributes), ',', '<br>', [rfReplaceAll])])
                                         + Format('<td nowrap>%s@</td>', [LField.DefaultValue])
                                         + Format('<td nowrap align="center">%s</td>', [BOOL_TXT[Boolean(LField.DataUpdatable)]])
                                         + Format('<td nowrap>%s@</td>', [ConvHtmlChar(LField.ValidationRule)])
                                         + Format('<td nowrap>%s@</td>', [ConvHtmlChar(LField.ValidationText)])
                                         );
                                try
                                    Write(F, Format('<td nowrap>%s</td>', [LField.Properties['Description']]));
                                except
                                    Write(F, '<td>@</td>');
                                end;
                                Writeln(F, '</tr>');
                            end;

                            Writeln(F, '</table>');
                        end;
                    end;
                    ProgPart.StepIt();

                    //---------------------------------------------------------
                    Writeln(F, Format('<h4 id="%s_relation"><a href="#%s">[VVbv (in %s)</a></h4>',
                                        [GetId(GMdb.FileName), GetId(GMdb.FileName), GMdb.FileName]));

                    //  [VBւ̎Q
                    LRelationCount := GMdb.DB.Relations.Count;

                    //  [VP̂ւ̎Q
                    for j := 0 to LRelationCount - 1 do
                    begin
                        LRelation := GMdb.DB.Relations[j];

                        //  [V
                        Writeln(F, '<p><table cellpadding=3 cellspacing=0 border=0>');
                        Writeln(F, Format('<caption>%s</caption>', [LRelation.Name]));
                        Writeln(F, '<tr>');

                        //  e[u(}X^)
                        Writeln(F, '<td valign="top"><table cellpadding=3 cellspacing=0 border=1>');
                        Writeln(F, Format('<tr><th nowrap>%s</th></tr>', [LRelation.Table]));

                        //  tB[h(}X^)
                        Writeln(F, '<tr><td valign="top" nowrap>');
                        LFieldCount := LRelation.Fields.Count;
                        for k := 0 to LFieldCount - 1 do
                        begin
                            LField := LRelation.Fields[k];
                            Writeln(F, Format('%s<br>', [LField.Name]));
                        end;
                        Writeln(F, '</td></tr>');
                        Writeln(F, '</table></td>');

                        //  ۂG
                        Writeln(F, '<td valign="top"><table cellpadding=3 cellspacing=0 border=0>');
                        Writeln(F, '<tr><td>@</td></tr><tr><td valign="top" nowrap>@@FK<br>|||</td></tr>');
                        Writeln(F, '</table></td>');

                        //  e[u(Q?)
                        Writeln(F, '<td valign="top"><table cellpadding=3 cellspacing=0 border=1>');
                        Writeln(F, Format('<tr><th nowrap>%s</th></tr>', [LRelation.ForeignTable]));

                        //  tB[h(Q?)
                        Writeln(F, '<tr><td valign="top" nowrap>');
                        LTable := GMdb.DB.TableDefs[LRelation.ForeignTable];

                        //  X~X
                        try
                            LIndex := LTable.Indexes[LRelation.Name];
                            LFieldCount := LIndex.Fields.Count;

                            for k := 0 to LFieldCount - 1 do
                            begin
                                LField := LIndex.Fields[k];
                                Writeln(F, Format('%s<br>', [LField.Name]));
                            end;
                        except
                            on E:Exception do Writeln(F, 'QƐȂ(?)<br>' + E.Message);
                        end;

                        Writeln(F, '</td></tr>');
                        Writeln(F, '</table></td>');

                        //  ݒ
                        Writeln(F, '<td valign="top"><table cellpadding=3 cellspacing=0 border=0>');
                        Writeln(F, '<tr><td>@</td></tr><tr><td nowrap>');

                        Writeln(F, StringReplace(GetRelationAttr(LRelation.Attributes), ',', '<br>', [rfReplaceAll]));
                        Writeln(F, '</td></tr></table></td>');

                        Writeln(F, '</tr></table>');

                    end;
                    ProgPart.StepIt();

                    //  ƂĂ
                    GMdb.CloseConnection();
                    ProgPart.StepIt();
                    ProgTotal.StepIt();
                    ProgTotal.Refresh();
                end;
            end;

            //-----------------------------------------------------------------
            //  tb^o
            Ticks := GetTickCount() - Ticks;
            Writeln(F, '<p>' + IntToStr(Ticks) + 'msec.');
            Writeln(F, '<a href="#PAGE_TOP">TOP</a></p></body></html>');

        finally
            //  t@C
            CloseFile(F);
        end;
    except
        on E:Exception do
        begin
            MemOut.Lines.Add(E.Message);
        end;
    end;

    //-------------------------------------------------------------------------
    //  IuWFNg
    LMdbPath.Free();
    LIdList.Free();
    LPkList.Free();
    LFkList.Free();
    LUkList.Free();
    LClList.Free();
    LInList.Free();

    //  J[\߂
    Screen.Cursor := crDefault;
    Self.Color := clBtnFace;

    //  bN
    MemTarget.Enabled := True;
    PnlButton.Enabled := True;
end;

end.
